function [JR3,JR2,JR1,JL3,JL2,JL1]= ...
    Angular_Vel_Acc_calc_forward(ii,R_0_BRS_CG,R_0_BLS_CG,JR3,JR2,JR1,JL3,JL2,JL1,walk_para)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Angular_Vel_Acc_calc_forward.m
%Kvv_Ng MATLAB
%͈
% ii:CfbNX
%R_0_BRS_CG:[hW猩RS̏dSWx,y,z[mm]
%R_0_BLS_CG:[hW猩LS̏dSWx,y,z[mm]
%JR3:֐JR3̊px[rad]
%JR2:֐JR3̊px[rad]
%JR1:֐JR3̊px[rad]
%JL3:֐JL3̊px[rad]
%JL2:֐JL2̊px[rad]
%JL1:֐JL1̊px[rad]
%walk_para:Op[^̍\
%o͈
%\
%o
%JR3,JR2,JR1,JL3,JL2,JL1
%Lɑxthetadot[rad/s]ǉ
%Lɉxtheta2dot[rad/s2]ǉ
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Copyright (C) 2007 CYBERNET SYSTEMS CO.,LTD. All rights reserved.
%Verson 1.0 2007/02/05 Hiroumi Mita
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ts=walk_para.Ts;%Tv

%[Nϐ
con1=0;
con2=0;
con3=0;
con4=0;

if ii==1
    %TvOԍn=1̂Ƃ
    %xvZ
    JR3.thetadot(ii)=JR3.theta(ii)/(Ts^2);
    JR2.thetadot(ii)=JR2.theta(ii)/(Ts^2);
    JR1.thetadot(ii)=JR1.theta(ii)/(Ts^2);
    JL3.thetadot(ii)=JL3.theta(ii)/(Ts^2);
    JL2.thetadot(ii)=JL2.theta(ii)/(Ts^2);
    JL1.thetadot(ii)=JL1.theta(ii)/(Ts^2);

    %xvZ
    JR3.theta2dot(ii)=JR3.theta(ii)/(Ts^2);
    JR2.theta2dot(ii)=JR2.theta(ii)/(Ts^2);
    JR1.theta2dot(ii)=JR1.theta(ii)/(Ts^2);
    JL3.theta2dot(ii)=JL3.theta(ii)/(Ts^2);
    JL2.theta2dot(ii)=JL2.theta(ii)/(Ts^2);
    JL1.theta2dot(ii)=JL1.theta(ii)/(Ts^2);

end

%n>=2 sKvZl@
if(ii>=2)
    %En@ZWl0Ol0łȂ
    con1=(R_0_BRS_CG(ii).z==0) &&(R_0_BRS_CG(ii-1).z~=0);
    %n@ZWl0Ol0łȂ
    con2=(R_0_BLS_CG(ii).z==0) &&(R_0_BLS_CG(ii-1).z~=0);
end

if(ii>=3)
   %ؑց@EZWl0Ol0OXl0łȂ
    con3=(R_0_BRS_CG(ii).z==0)&&(R_0_BRS_CG(ii-1).z==0)&&(R_0_BRS_CG(ii-2).z~=0);
   %ؑց@ZWl0Ol0OXl0łȂ
    con4=(R_0_BLS_CG(ii).z==0)&&(R_0_BLS_CG(ii-1).z==0)&&(R_0_BLS_CG(ii-2).z~=0);
end

if(ii>=2)&&(con1||con2||con3||con4)
    abn_flag=1;%ُl
    else 
    abn_flag=0;%l
end    

if (ii>=2)&&(ii<=length(JR3.theta)-1)&&abn_flag==0
    %TvOԍn>=2n<=length(JR3.theta)-1
    %ُltOOFF̂Ƃ

    %xvZ
    JR3.thetadot(ii)=(JR3.theta(ii+1)-JR3.theta(ii))/Ts;
    JR2.thetadot(ii)=(JR2.theta(ii+1)-JR2.theta(ii))/Ts;
    JR1.thetadot(ii)=(JR1.theta(ii+1)-JR1.theta(ii))/Ts;
    JL3.thetadot(ii)=(JL3.theta(ii+1)-JL3.theta(ii))/Ts;
    JL2.thetadot(ii)=(JL2.theta(ii+1)-JL2.theta(ii))/Ts;
    JL1.thetadot(ii)=(JL1.theta(ii+1)-JL1.theta(ii))/Ts;

    %xvZ
    JR3.theta2dot(ii)=(JR3.theta(ii+1)-2*JR3.theta(ii)+JR3.theta(ii-1))/(Ts^2);
    JR2.theta2dot(ii)=(JR2.theta(ii+1)-2*JR2.theta(ii)+JR2.theta(ii-1))/(Ts^2);
    JR1.theta2dot(ii)=(JR1.theta(ii+1)-2*JR1.theta(ii)+JR1.theta(ii-1))/(Ts^2);
    JL3.theta2dot(ii)=(JL3.theta(ii+1)-2*JL3.theta(ii)+JL3.theta(ii-1))/(Ts^2);
    JL2.theta2dot(ii)=(JL2.theta(ii+1)-2*JL2.theta(ii)+JL2.theta(ii-1))/(Ts^2);
    JL1.theta2dot(ii)=(JL1.theta(ii+1)-2*JL1.theta(ii)+JL1.theta(ii-1))/(Ts^2);
end    

if (ii==length(JR3.theta))||(abn_flag==1)
    %TvOԍn=end܂ُ͈ltOON̂ƂA1Õf[^ƓƂB
    %xvZ

    %xvZ
    JR3.thetadot(ii)=JR3.thetadot(ii-1);
    JR2.thetadot(ii)=JR2.thetadot(ii-1);
    JR1.thetadot(ii)=JR1.thetadot(ii-1);
    JL3.thetadot(ii)=JL3.thetadot(ii-1);
    JL2.thetadot(ii)=JL2.thetadot(ii-1);
    JL1.thetadot(ii)=JL1.thetadot(ii-1);

    JR3.theta2dot(ii)=JR3.theta2dot(ii-1);
    JR2.theta2dot(ii)=JR2.theta2dot(ii-1);
    JR1.theta2dot(ii)=JR1.theta2dot(ii-1);
    JL3.theta2dot(ii)=JL3.theta2dot(ii-1);
    JL2.theta2dot(ii)=JL2.theta2dot(ii-1);
    JL1.theta2dot(ii)=JL1.theta2dot(ii-1);
end


