function y=robot_parameter()
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%robot_parameter.m
%{bg̃p[^
%Kvv_Ng MATLAB
%͈
%
%o͈
%y:\
%o
%l2 N2[mm]
%l3 N3[mm]
%w {bg̕[mm]
%s {bg̑TCY(sA͓)[mm]
%M_s RS,LS@[kg]
%Ix_s RS,LS xxCi[V[Kg.m^2]
%Iy_s RS,LS yyCi[V[Kg.m^2]
%Iz_s RS,LS zzCi[V[Kg.m^2]
%M_l23 R3,R2,L3,L2 [kg]
%Ix_l23 R3,R2,L3,L2 xxCi[V[Kg.m^2]
%Iy_l23 R3,R2,L3,L2 yyCi[V[Kg.m^2]
%Iz_l23 R3,R2,L3,L2 zzCi[V[Kg.m^2]
%M_w W [kg]
%Ix_w W xxCi[V[Kg.m^2]
%Iy_w W yyCi[V[Kg.m^2]
%Iz_w W zzCi[V[Kg.m^2]
%M_CGCTR dSߊ̎[kg]
%r_CGCTR dSߊӂ̒[m]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Copyright (C) 2007 CYBERNET SYSTEMS CO.,LTD. All rights reserved.
%Version 1.0 2007/02/05 Hiroumi Mita
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%N2
l2=100;%[mm]

%N3
l3=100;%[mm]

%{bg̕
w=100;%[mm]

%{bg̑/2(sA͓)
s=40;%[mm]

%{bg̏dS⏞ ӂ̒
r_CGCTR=w/4;%[mm]

%ގ:A~
ro=2.69*10^(-3)/(10^(-2))^3;%[kg/m^3]

%d͉x@z
G=9.8;%[m/s^2]

%ʂƊ[g
%(1)@s1_R,s1_L 
%`:́@AȒP̂ߑ͍̍lȂB
b=40/2*1e-3;%[m]
c=1/2*1e-3;%[m]
a=40/2*1e-3;%[m]
M_s=2*a*2*b*2*c*ro;%[kg]
Ix_s=1/3*(b^2)*M_s;%xxCi[V[Kg.m^2]
Iy_s=1/3*(a^2)*M_s;%yyCi[V[Kg.m^2]
Iz_s=1/3*(a^2+b^2)*M_s;%zzCi[V[Kg.m^2]

%(2) N@l2_R,l3_R,l2_L,l3_Lɋʁ@
%`:~
a=(10/2)*1e-3;%[m]
h=100e-3;%[m]
M_l23=pi*a^2*h*ro;%[kg]
Iz_l23=1/2*M_l23*a^2;%zzCi[V[Kg.m^2]
Ix_l23=(a^2/2+h^2/12)*M_l23;%xxCi[V[Kg.m^2]
Iy_l23=Ix_l23;%yyCi[V[Kg.m^2]

%(3) @W@
%`:~
a=(10/2)*1e-3;%[m]
h=100e-3;%[m]
M_w=pi*a^2*h*ro;%[kg]
Iy_w=1/2*M_w*a^2;%yyCi[V[Kg.m^2]
Ix_w=(a^2/2+h^2/12)*M_w;%xxCi[V[Kg.m^2]
Iz_w=Ix_w;%zzCi[V[Kg.m^2]

%(4) dS⏞
%`F
r=(w/2)*1e-3;%[m]
M_CGCTR=r^3*ro;%[kg]

%{bgp[^\̍쐬
y.l2=l2;%N2[mm]
y.l3=l3;%N3[mm]
y.w=w;%{bg̕[mm]
y.s=s;%{bg̑TCY(sA͓)[mm]

y.M_s=M_s;%RS,LS@[kg]
y.Ix_s=Ix_s;%RS,LS xxCi[V[Kg.m^2]
y.Iy_s=Iy_s;%RS,LS yyCi[V[Kg.m^2]
y.Iz_s=Iz_s;%RS,LS zzCi[V[Kg.m^2]

y.M_l23=M_l23;%R3,R2,L3,L2 [kg]
y.Ix_l23=Ix_l23;%R3,R2,L3,L2 xxCi[V[Kg.m^2]
y.Iy_l23=Iy_l23;%R3,R2,L3,L2 yyCi[V[Kg.m^2]
y.Iz_l23=Iz_l23;%R3,R2,L3,L2 zzCi[V[Kg.m^2]

y.M_w=M_w;%W [kg]
y.Ix_w=Ix_w;%W xxCi[V[Kg.m^2]
y.Iy_w=Iy_w;%W yyCi[V[Kg.m^2]
y.Iz_w=Iz_w;%W zzCi[V[Kg.m^2]

y.M_CGCTR=M_CGCTR;%dSߊ̎[kg]
y.r_CGCTR=r_CGCTR;%dSߊӂ̒[m]
