%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%symbolic_forward_kinamatics.m
%{bg̏^w̃V{bNvZ
% {bg^wV~[^p
%Kvv_Ng:MATLAB,Symbolic Math Toolbox
%{bg̎p̌vZ
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright (c) 2007 CYBERNET SYSTEMS CO.,LTD. All rights reserved.
% Version 1.0 20070131@݌v Hiroumi Mita
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
syms theta_R2 theta_R3
syms theta_L2 theta_L3
syms x0 w l2 l3

%Wn0烰R1ւ̓ϊs
%sړ[x,-w/2,0]'@yẢ] -pi/2+(theta_R2+theta_R3)
T_0_R1=[cos(-pi/2+(theta_R2+theta_R3)) 0 sin(-pi/2+(theta_R2+theta_R3))   x0; ...
                                     0 1                              0 -w/2; ...
       -sin(-pi/2+(theta_R2+theta_R3)) 0 cos(-pi/2+(theta_R2+theta_R3))    0; ...
                                     0 0                             0    1];
T_0_R1=simple(T_0_R1);

%WnR1烰R2ւ̓ϊs
%sړ[0,0,l2]'@ỷ](-theta_R2)
T_R1_R2=[cos(-theta_R2) 0 sin(-theta_R2)  l2; ...
                      0 1              0   0; ...
        -sin(-theta_R2) 0 cos(-theta_R2)   0; ...
                      0 0              0   1];
T_R1_R2=simple(T_R1_R2)

%WnR2烰R3ւ̓ϊs
%sړ[0,0,l2]'@ỷ](pi/2-theta_R3)
T_R2_R3=[cos(pi/2-theta_R3) 0 sin(pi/2-theta_R3) l3; ...
                          0 1                  0  0; ...
        -sin(pi/2-theta_R3) 0 cos(pi/2-theta_R3)  0; ...
                          0 0                  0  1];
T_R2_R3=simple(T_R2_R3)

%WnR3烰L3ւ̓ϊs
%sړ[0,w,0]'@ỷ](pi/2-(-theta_L3)
T_R3_L3=[cos(pi/2+theta_L3) 0 sin(pi/2+theta_L3) 0; ...
                          0 1                  0 w; ...
        -sin(pi/2+theta_L3) 0 cos(pi/2+theta_L3) 0; ...
      0 0 0 1];
T_R3_L3=simple(T_R3_L3)

%WnL3烰L2ւ̓ϊs
%sړ[l3,0,0]'@ỷ](theta_L2)
T_L3_L2=[cos(theta_L2) 0 sin(theta_L2) l3; ...
                     0 1             0  0; ...
        -sin(theta_L2) 0 cos(theta_L2)  0; ...
                     0 0             0  1];
T_L3_L2=simple(T_L3_L2)

%WnL2烰L1ւ̓ϊs
%sړ[l2,0,0]'@ỷ]-(pi/2theta_L3+theta_L2)
T_L2_L1=[cos(-(pi/2+theta_L3+theta_L2)) 0 sin(-(pi/2+theta_L3+theta_L2)) l2; ...
                                      0 1                              0  0; ...
        -sin(-(pi/2+theta_L3+theta_L2)) 0 cos(-(pi/2+theta_L3+theta_L2))  0; ...
              0 0 0 1];
T_L2_L1=simple(T_L2_L1)

%WnR1猩JR2̍W
R_R1_JR2=[l2 0 0].'
%WnR2猩JR3̍W
R_R2_JR3=[l3 0 0].'
%WnR3猩JL3̍W
R_R3_JL3=[0 w 0].'
%WnL3猩JL2̍W
R_L3_JL2=[l3 0 0].'
%WnL2猩JL1̍W
R_L2_JL1=[l2 0 0].'

%Wn0猩JR2̍W
R_0_JR2=T_0_R1*[R_R1_JR2;1];
R_0_JR2=simple(R_0_JR2)

%Wn0猩JR3̍W
R_0_JR3=T_0_R1*T_R1_R2*[R_R2_JR3;1];
R_0_JR3=simple(R_0_JR3)

%Wn0猩JL3̍W
R_0_JL3=T_0_R1*T_R1_R2*T_R2_R3*[R_R3_JL3;1];
R_0_JL3=simple(R_0_JL3)

%Wn0猩JL2̍W
R_0_JL2=T_0_R1*T_R1_R2*T_R2_R3*T_R3_L3*[R_L3_JL2;1];
R_0_JL2=simple(R_0_JL2)

%Wn0猩JL1̍W
R_0_JL1=T_0_R1*T_R1_R2*T_R2_R3*T_R3_L3*T_L3_L2*[R_L2_JL1;1];
R_0_JL1=simple(R_0_JL1)
